#!/usr/bin/env python
import sys, os, string, time, signal
# from insert import *
from string import split
from os import spawnv, P_NOWAIT
from Tkinter import *
from tkFileDialog import askopenfilename, asksaveasfilename
import popen2
#from fontlist import choosefont


root = Tk()
nouveau = PhotoImage(file=(os.path.join("Icons","new.gif")))
ouvrir = PhotoImage(file=(os.path.join("Icons","open.gif")))
sauver = PhotoImage(file=(os.path.join("Icons","save.gif")))
lancer = PhotoImage(file=(os.path.join("Icons","run.gif")))
stop = PhotoImage(file=(os.path.join("Icons","stop.gif")))


# ajouter undo
# ajouter buffers pour multifentres
# ajouter close dans menu
# ajouter les 'insert' pov avec cascades
# ajouter chemin pour executable
# creer fichier ini pour garder parametres :
#                             endroit de l'exe
#                             paramtres de rendu




plat=sys.platform
global filename


class mainWin:
  def __init__(self,tkRoot):
    self.tkRoot=tkRoot
    self.createWidgets()
    return None




class App:



## ---------------------- Create GUI ----------------------

    def __init__(self, master):



# -------------------- Chargement du fichier ini ------------


        try:
          self.loadini()
        except IOError:
          self.loadinierror()
        except IndexError:
          self.loadinierror()

## ---------------------- Mainframe ----------------------


	mframe = Frame(master)
        mframe.pack(expand=1, fill=BOTH)
        mframe.focus_force()
        frame_input=Frame(mframe)

## ---------------------- Menu ----------------------

        menubar=Menu(frame_input)
        filemenu=Menu(menubar,tearoff=0)
        filemenu.add_command(label="New",underline=0,command=self.clr)
        filemenu.add_command(label="Open",underline=0,command=self.enter_text)
        filemenu.add_command(label="Close")
        filemenu.add_command(label="Save",command=self.save)
        filemenu.add_command(label="Save As",command=self.saveas)
        filemenu.add_separator()
        filemenu.add_command(label="Quit",command=self.quitter)
        menubar.add_cascade(label="File",menu=filemenu)

        editmenu=Menu(menubar,tearoff=0)
        editmenu.add_command(label="Cut           Ctrl+x", underline=19,command=self.cut)
        editmenu.add_command(label="Copy        Ctrl+c", underline=17,command=self.copy)
        editmenu.add_command(label="Paste       Ctrl+v", underline=17,command=self.paste)
        editmenu.add_command(label="Select all  Ctrl+a", underline=17,state="disabled") #command=self.selectall)        
        menubar.add_cascade(label="Edit",menu=editmenu)

        rendermenu=Menu(menubar,tearoff=0)
        rendermenu.add_command(label="Render", command=self.render)
        rendermenu.add_command(label="POV-Ray location", command=self.show_location)
        menubar.add_cascade(label="Render",menu=rendermenu)

        insertmenu=Menu(menubar,tearoff=0)

# Scene templates
        insertmenuscenetemplates=Menu(insertmenu,tearoff=0)
        insertmenuscenetemplates.add_command(label="Basic scene", command = lambda : self.insert_example("10 - Basic scene.txt"))
        insertmenuscenetemplates.add_command(label="Orthographic scene", command = lambda : self.insert_example("20 - Orthographic scene.txt"))
        insertmenuscenetemplates.add_command(label="Radiosity scene", command = lambda : self.insert_example("30 - Radiosity scene.txt"))
        insertmenuscenetemplates.add_command(label="Photons scene", command = lambda : self.insert_example("40 - Photons scene.txt"))
        insertmenuscenetemplates.add_command(label="Checkered floor",command = lambda : self.insert_example("50 - Checkered floor.txt"))
        insertmenuscenetemplates.add_command(label="Image map", command = lambda : self.insert_example("60 - Image Map.txt"))
        insertmenuscenetemplates.add_command(label="Text fonts", command = lambda : self.insert_example("70 - Text Fonts.txt"))
        insertmenu.add_cascade(label="Scene templates", menu=insertmenuscenetemplates)
        


# Headers
        insertmenuheaders=Menu(insertmenu,tearoff=0)
        insertmenuheaders.add_command(label="Scene file header", command = lambda : self.insert_example("10 - Scene File Header.txt"))
        insertmenuheaders.add_command(label="Standard includes", command = lambda : self.insert_example("20 - Standard includes.txt"))
        insertmenuheaders.add_command(label="Additional includes", command = lambda : self.insert_example("30 - Additional includes.txt  "))
        insertmenu.add_cascade(label="Headers", menu=insertmenuheaders)

#  Include files
        insertmenuinclude=Menu(insertmenu,tearoff=0)
        insertmenuinclude.add_command(label="arrays", command = lambda : self.insert_example("'arrays.inc'.txt"))
        insertmenuinclude.add_command(label="colors", command = lambda : self.insert_example("'colors.inc'.txt"))
        insertmenuinclude.add_command(label="finish", command = lambda : self.insert_example("'finish.inc'.txt"))
        insertmenuinclude.add_command(label="functions", command = lambda : self.insert_example("'functions.inc'.txt"))
        insertmenuinclude.add_command(label="glass", command = lambda : self.insert_example("'glass.inc'.txt"))
        insertmenuinclude.add_command(label="math", command = lambda : self.insert_example("'math.inc'.txt"))
        insertmenuinclude.add_command(label="metals", command = lambda : self.insert_example("'metals.inc'.txt"))
        insertmenuinclude.add_command(label="rand", command = lambda : self.insert_example("'rand.inc'.txt"))
        insertmenuinclude.add_command(label="shapes", command = lambda : self.insert_example("'shapes.inc'.txt"))
        insertmenuinclude.add_command(label="shapes2", command = lambda : self.insert_example("'shapes2.inc'.txt"))
        insertmenuinclude.add_command(label="skies", command = lambda : self.insert_example("'skies.inc'.txt"))
        insertmenuinclude.add_command(label="stones", command = lambda : self.insert_example("'stones.inc'.txt"))
        insertmenuinclude.add_command(label="strings", command = lambda : self.insert_example("'strings.inc'.txt"))
        insertmenuinclude.add_command(label="transforms", command = lambda : self.insert_example("'transforms.inc'.txt"))
        insertmenuinclude.add_command(label="woods", command = lambda : self.insert_example("'woods.inc'.txt"))
        insertmenu.add_cascade(label="Include files", menu=insertmenuinclude)


        

#  Statements
        insertmenustatement=Menu(insertmenu,tearoff=0)
        insertmenustatement.add_command(label="background", command = lambda : self.insert_example("10 - background.txt"))
        insertmenustatement.add_command(label="global settings", command = lambda : self.insert_example("20 - global_settings.txt"))   
        insertmenustatement.add_command(label="adc_bailout", command = lambda : self.insert_example("30 - adc_bailout.txt"))
        insertmenustatement.add_command(label="ambient_light", command = lambda : self.insert_example("40 - ambient_light.txt"))
        insertmenustatement.add_command(label="assumed_gamma", command = lambda : self.insert_example("50 - assumed_gamma.txt"))
        insertmenustatement.add_command(label="charset", command = lambda : self.insert_example("charset.txt"))
        insertmenustatement.add_command(label="hf_gray_16", command = lambda : self.insert_example("70 - hf_gray_16.txt"))   
        insertmenustatement.add_command(label="irid_wavelength", command = lambda : self.insert_example("80 - irid_wavelength.txt"))   
        insertmenustatement.add_command(label="max_intersections", command = lambda : self.insert_example("90 - max_intersections.txt"))   
        insertmenustatement.add_command(label="max_trace_level", command = lambda : self.insert_example("A0 - max_trace_level.txt"))
        insertmenustatement.add_command(label="noise_generator", command = lambda : self.insert_example("B0 - noise_generator.txt"))   
        insertmenustatement.add_command(label="number_of_waves", command = lambda : self.insert_example("C0 - number_of_waves.txt"))
        insertmenu.add_cascade(label="Statements", menu=insertmenustatement)




#  Expressions
        insertmenuexpressions=Menu(insertmenu,tearoff=0)
        insertmenuexpressions.add_command(label="Bounds extents", command = lambda : self.insert_example("Bounds extents.txt"))   
        insertmenuexpressions.add_command(label="Built-in Ids", command = lambda : self.insert_example("Built-in Ids.txt"))   
        insertmenuexpressions.add_command(label="Conditional expression", command = lambda : self.insert_example("Conditional Expression.txt"))      
        insertmenuexpressions.add_command(label="Float functions", command = lambda : self.insert_example("Float Functions.txt"))   
        insertmenuexpressions.add_command(label="Logical operators", command = lambda : self.insert_example("Logical Operators.txt"))   
        insertmenuexpressions.add_command(label="Math operators", command = lambda : self.insert_example("Math Operators.txt"))
        insertmenuexpressions.add_command(label="Relational operators", command = lambda : self.insert_example("Relational Operators.txt"))
        insertmenuexpressions.add_command(label="Strings", command = lambda : self.insert_example("Strings.txt"))
        insertmenuexpressions.add_command(label="Trace", command = lambda : self.insert_example("Trace.txt"))
        insertmenuexpressions.add_command(label="Vector component", command = lambda : self.insert_example("Vector components.txt"))   
        insertmenuexpressions.add_command(label="Vector functions", command = lambda : self.insert_example("Vector Functions.txt"))   
        insertmenu.add_cascade(label="Expressions", menu=insertmenuexpressions)

#  Misc
        insertmenumisc=Menu(insertmenu,tearoff=0)
        insertmenumisc.add_command(label="declare", command = lambda : self.insert_example("declare.txt"))
        insertmenumisc.add_command(label="default", command = lambda : self.insert_example("default.txt"))   
        insertmenumisc.add_command(label="if example", command = lambda : self.insert_example("if example.txt"))   
        insertmenumisc.add_command(label="if", command = lambda : self.insert_example("if.txt"))   
        insertmenumisc.add_command(label="ifdef example", command = lambda : self.insert_example("ifdef example.txt"))   
        insertmenumisc.add_command(label="local", command = lambda : self.insert_example("local.txt"))   
        insertmenumisc.add_command(label="macro", command = lambda : self.insert_example("macro.txt"))   
        insertmenumisc.add_command(label="messages", command = lambda : self.insert_example("messages.txt"))
        insertmenumisc.add_command(label="switch example", command = lambda : self.insert_example("switch example.txt"))   
        insertmenumisc.add_command(label="switch", command = lambda : self.insert_example("switch.txt"))
        insertmenumisc.add_command(label="undef", command = lambda : self.insert_example("undef.txt"))
        insertmenumisc.add_command(label="version", command = lambda : self.insert_example("version.txt"))
        insertmenumisc.add_command(label="while", command = lambda : self.insert_example("while.txt"))   
        insertmenu.add_cascade(label="Misc. Directives", menu=insertmenumisc)



#  Animation
        insertmenuanimation=Menu(insertmenu,tearoff=0)
        insertmenuanimation.add_command(label="clock", command = lambda : self.insert_example("10 - clock.txt"))
        insertmenuanimation.add_command(label="additional animation variables", command = lambda : self.insert_example("20 - additional animation variables.txt"))
        insertmenu.add_cascade(label="Animation", menu=insertmenuanimation)




#  CSG
        insertmenucsg=Menu(insertmenu,tearoff=0)
        insertmenucsg.add_command(label="difference", command = lambda : self.insert_example("difference.txt"))
        insertmenucsg.add_command(label="intersection", command = lambda : self.insert_example("intersection.txt"))
        insertmenucsg.add_command(label="inverse", command = lambda : self.insert_example("inverse.txt"))
        insertmenucsg.add_command(label="merge", command = lambda : self.insert_example("merge.txt"))
        insertmenucsg.add_command(label="union", command = lambda : self.insert_example("union.txt"))
        insertmenucsg.add_command(label="cut_away textures", command = lambda : self.insert_example("cutaway_textures.txt"))
        insertmenu.add_cascade(label="CSG Operations", menu=insertmenucsg)




#  Material
        insertmenumaterial=Menu(insertmenu,tearoff=0)
        insertmenumaterial.add_command(label="interior", command = lambda : self.insert_example("interior.txt"))
        insertmenumaterial.add_command(label="material", command = lambda : self.insert_example("material.txt"))
        insertmenumaterial.add_command(label="media", command = lambda : self.insert_example("media.txt"))
        insertmenu.add_cascade(label="Material", menu=insertmenumaterial)




#  Textures
        insertmenutexture=Menu(insertmenu,tearoff=0)
        insertmenutexturemap=Menu(insertmenutexture,tearoff=0)
        insertmenutexturemap.add_command(label="bump_map normal", command = lambda : self.insert_example("bump_map normal.txt"))
        insertmenutexturemap.add_command(label="image_map pigment", command = lambda : self.insert_example("image_map pigment.txt"))
        insertmenutexturemap.add_command(label="material_map texture", command = lambda : self.insert_example("material_map texture.txt"))
        insertmenutexturemap.add_command(label="tiles texture", command = lambda : self.insert_example("tiles texture.txt"))

        insertmenutexture.add_cascade(label="Texture maps", menu=insertmenutexturemap)

        insertmenutexture.add_command(label="color", command = lambda : self.insert_example("color.txt"))
        insertmenutexture.add_command(label="finish properties", command = lambda : self.insert_example("finish properties.txt"))
        insertmenutexture.add_command(label="color_map", command = lambda : self.insert_example("color_map.txt"))
        insertmenutexture.add_command(label="function image type", command = lambda : self.insert_example("function image type.txt"))
        insertmenutexture.add_command(label="interior_texture", command = lambda : self.insert_example("interior_texture.txt"))
        insertmenutexture.add_command(label="normal component", command = lambda : self.insert_example("normal component.txt"))
        insertmenutexture.add_command(label="pigment component", command = lambda : self.insert_example("pigment component.txt"))
        insertmenutexture.add_command(label="texture example", command = lambda : self.insert_example("texture example.txt"))
        insertmenutexture.add_command(label="triangle texture interpolation", command = lambda : self.insert_example("triangle texture interpolation.txt"))
        insertmenutexture.add_command(label="uv_mapping", command = lambda : self.insert_example("uv_mapping.txt"))
        insertmenu.add_cascade(label="Textures", menu=insertmenutexture)




#  Special effects
        insertmenueffects=Menu(insertmenu,tearoff=0)
        insertmenueffects.add_command(label="Fog definition", command = lambda : self.insert_example("10 - Fog definition.txt"))
        insertmenueffects.add_command(label="Ambient fog", command = lambda : self.insert_example("20 - Ambient fog.txt"))
        insertmenueffects.add_command(label="Ground fog", command = lambda : self.insert_example("30 - Ground fog.txt"))
        insertmenueffects.add_command(label="Atmospheric media", command = lambda : self.insert_example("40 - Atmospheric media.txt"))
        insertmenueffects.add_command(label="sky_sphere", command = lambda : self.insert_example("50 - sky_sphere.txt"))
        insertmenueffects.add_command(label="rainbow", command = lambda : self.insert_example("60 - rainbow.txt"))
        insertmenueffects.add_command(label="Global photons", command = lambda : self.insert_example("70 - Global photons.txt"))
        insertmenueffects.add_command(label="Light source photons", command = lambda : self.insert_example("80 - Light source photons.txt"))
        insertmenueffects.add_command(label="Object photons", command = lambda : self.insert_example("80 - Light source photons.txt"))
        insertmenueffects.add_command(label="radiosity", command = lambda : self.insert_example("A0 - radiosity.txt"))
        insertmenu.add_cascade(label="Special effects", menu=insertmenueffects)




#  Light sources
        insertmenulight=Menu(insertmenu,tearoff=0)
        insertmenulight.add_command(label="area_light", command = lambda : self.insert_example("area_light.txt"))
        insertmenulight.add_command(label="Cylindrical light", command = lambda : self.insert_example("Cylindrical light.txt"))
        insertmenulight.add_command(label="Light definition",command = lambda : self.insert_example("Light definition.txt"))
        insertmenulight.add_command(label="Light fading", command = lambda : self.insert_example("Light fading.txt"))
        insertmenulight.add_command(label="light_group", command = lambda : self.insert_example("light_group.txt"))
        insertmenulight.add_command(label="looks_like", command = lambda : self.insert_example("looks_like.txt"))
        insertmenulight.add_command(label="parallel", command = lambda : self.insert_example("parallel.txt"))
        insertmenulight.add_command(label="point light",command = lambda : self.insert_example("Point light.txt"))
        insertmenulight.add_command(label="projected_through", command = lambda : self.insert_example("projected_through.txt"))
        insertmenulight.add_command(label="Spotlight", command = lambda : self.insert_example("Spotlight.txt"))
        insertmenu.add_cascade(label="Light Sources", menu=insertmenulight)

#  Camera
        insertmenucamera=Menu(insertmenu,tearoff=0)
        insertmenucamera.add_command(label="A typical camera", command = lambda : self.insert_example("A typical camera.txt"))
        insertmenucamera.add_command(label="Camera definition", command = lambda : self.insert_example("Camera definition.txt"))
        insertmenucamera.add_command(label="cylinder camera", command = lambda : self.insert_example("cylinder camera.txt"))
        insertmenucamera.add_command(label="fisheye camera", command = lambda : self.insert_example("fisheye camera.txt"))
        insertmenucamera.add_command(label="focal_blur",command = lambda : self.insert_example("focal blur camera.txt"))
        insertmenucamera.add_command(label="normal pertubed camera", command = lambda : self.insert_example("normal perturbed camera.txt"))
        insertmenucamera.add_command(label="omnimax camera", command = lambda : self.insert_example("omnimax camera.txt"))
        insertmenucamera.add_command(label="orthographic camera", command = lambda : self.insert_example("orthographic camera.txt"))
        insertmenucamera.add_command(label="panoramic camera", command = lambda : self.insert_example("panoramic camera.txt"))
        insertmenucamera.add_command(label="perspective camera", command = lambda : self.insert_example("perspective camera.txt"))
        insertmenucamera.add_command(label="sky camera", command = lambda : self.insert_example("sky camera.txt"))
        insertmenucamera.add_command(label="spherical camera", command = lambda : self.insert_example("spherical camera.txt"))        
        insertmenucamera.add_command(label="ultra_wide_angle camera", command = lambda : self.insert_example("ultra_wide_angle camera.txt"))
        insertmenu.add_cascade(label="Cameras", menu=insertmenucamera)





# SHAPES
        insertmenushape=Menu(insertmenu,tearoff=0)
        insertmenushape.add_command(label="bicubic_patch",command = lambda : self.insert_example("bicubic_patch.txt"))
        insertmenushape.add_command(label="blob",command = lambda : self.insert_example("blob.txt"))
        insertmenushape.add_command(label="box",command = lambda : self.insert_example("box.txt"))
        insertmenushape.add_command(label="cone",command = lambda : self.insert_example("cone.txt"))
        insertmenushape.add_command(label="cubic",command = lambda : self.insert_example("cubic.txt"))
        insertmenushape.add_command(label="cylinder",command = lambda : self.insert_example("cylinder.txt"))
        insertmenushape.add_command(label="disc",command = lambda : self.insert_example("disc.txt"))
        insertmenushape.add_command(label="fractal",command = lambda : self.insert_example("fractal.txt"))
        insertmenushape.add_command(label="height_field",command = lambda : self.insert_example("height_field.txt"))
        insertmenushape.add_command(label="isosurface",command = lambda : self.insert_example("isosurface.txt"))
        insertmenushape.add_command(label="lathe",command = lambda : self.insert_example("lathe.txt"))
        insertmenushape.add_command(label="mesh",command = lambda : self.insert_example("mesh.txt"))
        insertmenushape.add_command(label="mesh2",command = lambda : self.insert_example("mesh2.txt"))
        insertmenushape.add_command(label="parametric",command = lambda : self.insert_example("parametric.txt"))
        insertmenushape.add_command(label="plane",command = lambda : self.insert_example("plane.txt"))
        insertmenushape.add_command(label="polygon",command = lambda : self.insert_example("polygon.txt"))
        insertmenushape.add_command(label="polynomial",command = lambda : self.insert_example("polynomial.txt"))
        insertmenushape.add_command(label="prim",command = lambda : self.insert_example("prism.txt"))
        insertmenushape.add_command(label="quadric",command = lambda : self.insert_example("quadric.txt"))
        insertmenushape.add_command(label="smooth_triangle",command = lambda : self.insert_example("B0 - smooth_triangle.txt"))
        insertmenushape.add_command(label="sphere",command = lambda : self.insert_example("sphere.txt"))
        insertmenushape.add_command(label="sphere_sweep",command = lambda : self.insert_example("sphere_sweep.txt"))
        insertmenushape.add_command(label="superellipsoid",command = lambda : self.insert_example("superellipsoid.txt"))
        insertmenushape.add_command(label="surface of revolution",command = lambda : self.insert_example("surface of revolution.txt"))
        insertmenushape.add_command(label="text",command = lambda : self.insert_example("text.txt"))
        insertmenushape.add_command(label="torus",command = lambda : self.insert_example("torus.txt"))
        insertmenushape.add_command(label="triangle", command = lambda : self.insert_example("triangle.txt"))
        insertmenu.add_cascade(label="Shapes", menu=insertmenushape)



# Shape Modifiers
        insertmenushapemod=Menu(insertmenu,tearoff=0)
        insertmenushapemod.add_command(label="bounded_by", command = lambda : self.insert_example("bounded_by.txt"))
        insertmenushapemod.add_command(label="clipped_by", command = lambda : self.insert_example("clipped_by.txt"))
        insertmenushapemod.add_command(label="double_illuminate", command = lambda : self.insert_example("double_illuminate.txt"))
        insertmenushapemod.add_command(label="hollow", command = lambda : self.insert_example("hollow.txt"))
        insertmenushapemod.add_command(label="no_image", command = lambda : self.insert_example("no_image.txt"))
        insertmenushapemod.add_command(label="no_reflection", command = lambda : self.insert_example("no_reflection.txt"))
        insertmenushapemod.add_command(label="no_shadow", command = lambda : self.insert_example("no_shadow.txt"))
        insertmenushapemod.add_command(label="open", command = lambda : self.insert_example("open.txt"))
        insertmenushapemod.add_command(label="sturm", command = lambda : self.insert_example("sturm.txt"))
        insertmenu.add_cascade(label="Shape modifier", menu=insertmenushapemod)




# Patterns A-M
        insertmenupatternam=Menu(insertmenu,tearoff=0)
        insertmenupatternam.add_command(label="agate", command = lambda : self.insert_example("agate.txt"))
        insertmenupatternam.add_command(label="average", command = lambda : self.insert_example("average.txt"))
        insertmenupatternam.add_command(label="boxed", command = lambda : self.insert_example("boxed.txt"))
        insertmenupatternam.add_command(label="bozo", command = lambda : self.insert_example("bozo.txt"))
        insertmenupatternam.add_command(label="brick", command = lambda : self.insert_example("brick.txt"))
        insertmenupatternam.add_command(label="bumps", command = lambda : self.insert_example("bumps.txt"))
        insertmenupatternam.add_command(label="cells", command = lambda : self.insert_example("cells.txt"))
        insertmenupatternam.add_command(label="checker", command = lambda : self.insert_example("checker.txt"))
        insertmenupatternam.add_command(label="crakcle", command = lambda : self.insert_example("crackle.txt"))
        insertmenupatternam.add_command(label="cylindrical", command = lambda : self.insert_example("cylindrical.txt"))
        insertmenupatternam.add_command(label="density_file", command = lambda : self.insert_example("density_file.txt"))
        insertmenupatternam.add_command(label="dents", command = lambda : self.insert_example("dents.txt"))
        insertmenupatternam.add_command(label="facets", command = lambda : self.insert_example("facets.txt"))
        insertmenupatternam.add_command(label="fractal", command = lambda : self.insert_example("fractal.txt"))
        insertmenupatternam.add_command(label="function", command = lambda : self.insert_example("function.txt"))
        insertmenupatternam.add_command(label="gradient", command = lambda : self.insert_example("gradient.txt"))
        insertmenupatternam.add_command(label="granite", command = lambda : self.insert_example("granite.txt"))
        insertmenupatternam.add_command(label="hexagon", command = lambda : self.insert_example("hexagon.txt"))
        insertmenupatternam.add_command(label="image_pattern", command = lambda : self.insert_example("image_pattern.txt"))
        insertmenupatternam.add_command(label="leopard", command = lambda : self.insert_example("leopard.txt"))
        insertmenupatternam.add_command(label="marble", command = lambda : self.insert_example("marble.txt"))
        insertmenu.add_cascade(label="Patterns A-M",menu=insertmenupatternam)




# Patterns N-Z
        insertmenupatternz=Menu(insertmenu,tearoff=0)
        insertmenupatternz.add_command(label="object", command =lambda : self.insert_example("object.txt"))
        insertmenupatternz.add_command(label="onion", command = lambda : self.insert_example("onion.txt"))
        insertmenupatternz.add_command(label="pigment_pattern", command = lambda : self.insert_example("pigment_pattern.txt"))
        insertmenupatternz.add_command(label="planar", command = lambda : self.insert_example("planar.txt"))
        insertmenupatternz.add_command(label="quilted", command = lambda : self.insert_example("quilted.txt"))
        insertmenupatternz.add_command(label="radial", command = lambda : self.insert_example("radial.txt"))
        insertmenupatternz.add_command(label="ripples", command = lambda : self.insert_example("ripples.txt"))
        insertmenupatternz.add_command(label="slope", command = lambda : self.insert_example("slope.txt"))
        insertmenupatternz.add_command(label="spherical", command = lambda : self.insert_example("spherical.txt"))
        insertmenupatternz.add_command(label="spiral1", command = lambda : self.insert_example("spiral1.txt"))
        insertmenupatternz.add_command(label="spiral2", command = lambda : self.insert_example("spiral2.txt"))
        insertmenupatternz.add_command(label="spotted", command = lambda : self.insert_example("spotted.txt"))
        insertmenupatternz.add_command(label="waves", command = lambda : self.insert_example("waves.txt"))
        insertmenupatternz.add_command(label="wood", command = lambda : self.insert_example("wood.txt"))
        insertmenupatternz.add_command(label="wrinkles", command = lambda : self.insert_example("wrinkles.txt"))
        insertmenu.add_cascade(label="Patterns N-Z",menu=insertmenupatternz)

  

#        insertmenufinish=Menu(insertmenu,tearoff=0)
#        insertmenufinish.add_command(label="ambient", command=self.render)
#        insertmenufinish.add_command(label="attenuation", command=self.render)
#        insertmenufinish.add_command(label="brilliance", command=self.render)
#        insertmenufinish.add_command(label="caustics", command=self.render)
#        insertmenufinish.add_command(label="crand", command=self.render)
#        insertmenufinish.add_command(label="diffuse", command=self.render)
#        insertmenufinish.add_command(label="ior", command=self.render)
#        insertmenufinish.add_command(label="irid", command=self.render)
#        insertmenufinish.add_command(label="metallic", command=self.render)
#        insertmenufinish.add_command(label="phong", command=self.render)
#        insertmenufinish.add_command(label="phong_size", command=self.render)
#        insertmenufinish.add_command(label="reflection", command=self.render)
#        insertmenufinish.add_command(label="roughess", command=self.render)
#        insertmenufinish.add_command(label="specular", command=self.render)

#        insertmenu.add_cascade(label="Finish",menu=insertmenufinish)


        

        optionsmenu=Menu(menubar,tearoff=0)
        optionsmenu.add_command(label="Font",command=self.choose_font)
        optionsmenu.add_command(label="Force syntax coloring",state="disabled",command=self.clr)
        menubar.add_cascade(label="Options",menu=optionsmenu)

        root.config(menu=menubar)

        menubar.add_cascade(label="Insert",menu=insertmenu)



## ---------------------- Buttons ----------------------

        frame_buttons=Frame(mframe)

        self.button_new = Button(frame_buttons, image=nouveau, width=45, relief=FLAT,command=self.clr)
        self.button_new.pack(side=LEFT)
        self.button_open = Button(frame_buttons, image=ouvrir, width=45, relief=FLAT,command=self.enter_text)
        self.button_open.pack(side=LEFT)
        self.button_save = Button(frame_buttons, image=sauver, width=45, relief=FLAT,command=self.save)
        self.button_save.pack(side=LEFT)
        self.button_render = Button(frame_buttons, image=lancer, width=45, relief=FLAT,command=self.render)
        self.button_render.pack(side=LEFT)
        self.button_kill = Button(frame_buttons, image=stop, width=45, relief=FLAT,command=self.kill)
        self.button_kill.pack(side=LEFT)
	frame_buttons.pack(expand=0, fill=BOTH)



## ---------------------- Editor ----------------------


        self.text = Text(frame_input,font=(font, font_size),wrap=NONE)
        self.yscroll_i = Scrollbar(frame_input,orient=VERTICAL, command=self.text.yview)
        self.xscroll_i = Scrollbar(frame_input,orient=HORIZONTAL, command=self.text.xview)
        
        self.yscroll_i.pack(side=RIGHT, fill=Y)
        self.xscroll_i.pack(side=BOTTOM, fill=X)
        self.text['yscrollcommand']=self.yscroll_i.set
        self.text['xscrollcommand']=self.xscroll_i.set        
        
        self.text.pack(side=LEFT,expand=1, fill=BOTH, )

        frame_input.pack(expand=1, fill=BOTH)





## ---------------------- Shortcuts ----------------------

        bind_class=self.text.bind_class
        bind_class('UPD','<KeyPress>',self.keyPress)
        bind_class('UPD','<ButtonPress>',self.keyPress)
        bind_class('UPD','<Motion>',self.keyPress)
        bind_class('UPD','<ButtonRelease>',self.keyPress)
        bind_class('UPD','<Control-c>">',self.copy)
        bind_class('UPD','<Control-x>">',self.cut)
        bind_class('UPD','<Control-v>">',self.paste)
        bind_class('UPD','<Control-n>">',self.clr)
        bind_class('UPD','<Control-o>">',self.enter_text)        
#        bind_class('UPD','<KeyRelease>',self.keyRelease)


        oldtags = self.text.bindtags()
        self.text.bindtags(oldtags+('UPD',))


## ---------------------- Output ----------------------

	frame_output=Frame(mframe)
        self.text_out = Text(frame_output,state=NORMAL,height=10)
        self.text_out.pack(side=LEFT,expand=1, fill=BOTH)
        self.scroll = Scrollbar(frame_output, command=self.text_out.yview)
        self.text_out.configure(yscrollcommand=self.scroll.set)
        self.scroll.pack(side=RIGHT, fill=Y)
        frame_output.pack(expand=0, fill=BOTH)


## ---------------------- Status Bar ----------------------


	frame_status_bar=Frame(mframe)
	self.parameters = Label(frame_status_bar,text="Parameters : ", anchor="w",bg='gray70')
	self.parameters.pack(side='left')
	self.fill_params=Entry(frame_status_bar,bg='gray100')
	self.fill_params.insert(INSERT,params)
	self.fill_params.pack(side='left', expand=1, fill=BOTH)
        self.status_filename1 = Label(frame_status_bar,text="File : ",width=5, anchor="w",bg='gray70')
        self.status_filename1.pack(side=LEFT )
        self.status_filename2 = Label(frame_status_bar,text="",width=20,relief=FLAT, anchor="w", bg="gray90")
        self.status_filename2.pack(side=LEFT)



	self.status_line = Label(frame_status_bar,padx=1,
                                 relief=FLAT,bg="gray90",
                                 width=10,
                                 anchor="w",
                                  text="1"
                                 )
        self.status_line.pack(side='right')
        self.status_linetext = Label(frame_status_bar,padx=1,bg='gray70',
                                 width=7,
                                 anchor="w",
                                 text="Line : ")
        self.status_linetext.pack(side='right')


        frame_status_bar.pack(side=LEFT,expand=1, fill='x')


## ---------------------- Open file ----------------------

    def enter_text(self):
          filetypes = ( ( "Pov files","*.pov"), ( "Include files","*.inc"), ( "All","*"))
          self.filename = askopenfilename(filetypes=filetypes)
          if self.filename:
		self.text.delete(1.0, END)
		fd = open(self.filename)
	  for line in fd.readlines():
		if line.endswith("\r\n"):
			line = line[:-2] + "\n"
		self.text.insert(END, line)
	  fd.close()
          self.status_filename2.config(text=os.path.split(self.filename)[1])
          global directory
          directory=os.path.split(self.filename)[0]
          root.title("POV-RAY editor  [  "+self.filename+"  ]")



## ---------------------- Clear ----------------------

    def clr(self):
        self.text.delete(1.0, END)
        self.status_filename2.config(text="")
        root.title("POV-RAY editor")


## ---------------------- Save ----------------------

    def save(self, forPrt=None):
      try:
        script = self.text.get(1.0, END)
        if script:
          fd = open(self.filename, 'w')
          for line in string.split(script, '\n'):
            fd.write(line)
            fd.write('\n')
          fd.close
      except:
       self.saveas()



## ---------------------- Saveas ----------------------

    def saveas(self, forPrt=None):
      try:
        script = self.text.get(1.0, END)
        if script:
#          global filename
#          self.filename=".pov"
          filetypes = ( ( "Pov files","*.pov"), ( "Include files","*.inc"), ( "All","*"))
          self.filename = file = asksaveasfilename(filetypes=filetypes)
          fd = open(self.filename, 'w')
          for line in string.split(script, '\n'):
                fd.write(line)
                fd.write('\n')
          fd.close
          self.status_filename2.config(text=os.path.split(self.filename)[1])
          root.title("POV-RAY editor  [  "+self.filename+"  ]")
      except IOError:
        self.text_out.insert('end',"file not saved !")
        pass


## ---------------------- Render button ----------------------

    def render(self):
			global pid
			global params
			params=self.fill_params.get()
			script = self.text.get(1.0, END)
			if script:
				try:
					fd = open(self.filename, 'w')
					for line in string.split(script, '\n'):
						fd.write(line)
						fd.write('\n')
					fd.close
				except AttributeError:
					self.save()
				except IOError:
					self.save()





			cmd= "/bin/sh -c"+" "+self.exe_loc+" +i"+self.filename+" "+params+"2> /dev/fd/2"
#			cmd= "/bin/sh -c '{DISPLAY=:0.0;"+" "+self.exe_loc+" +i"+self.filename+" "+params+";}'"
#			cmd= "/bin/sh -c x-povray +i/mnt/win_c/Utile/Python/editeur/7.pov +w320 +h240 -f +dgt"
#			cmd="ls"
			print cmd
#			pin,pout,perr = popen2.popen3(cmd)
			pout,perr = os.popen2(cmd)
			self.pid = os.fork()
			print self.pid







			pipe_err= perr.readlines()
			for line in pipe_err:
				if line.endswith("\n"):
					line=line[:-1]+"\n"
					self.text_out.insert('1.0',line)
			self.text_out.yview('moveto', 1.0)
			



    def copy(self,event=None):
        try:
            global sel
            sel= ""
            sel = self.text.selection_get()
        except TclError:
            pass
        return "break"


    def cut(self,event=None):
        try:
            global sel
            sel= ""
            sel = self.text.selection_get()
            self.text.delete(SEL_FIRST, SEL_LAST)
        except TclError:
            pass
        return "break"



    def paste(self,event=None):
        try:
            self.text.insert('insert',sel)
        except TclError:
            pass
        return "break"


    def selectall(self,event=None):
        sel= ""
        sel = self.text.selection_get('1.0','end')
        print sel
















    def kill(Self):
			os.kill(pid,signal.SIGKILL)
#	self.button_render.config(image=lancer)

    def child(self):
	self.save()
	c2pread, c2pwrite = os.pipe()
   	self.pid = os.fork()
   	if self.pid == 0:            #Child
     		os.close(1)                        #close stdout
     		if os.dup(c2pwrite) != 1:
       			sys.stderr.write("bad write dup!\n")



		try:
			os.execv("x-povray",
                		("x-povray",
                 		"7.pov",
                 		"%s_GATE"%self.thissite))
     	   	finally:
       			print "child could not start"
       			os._exit(1)

	cmd= self.exe_loc+" +i"+self.filename+" "+params
	print self.exe_loc
	print cmd
	cm=cmd+" 2> /tmp/sortie.txt"
	pin,pout = os.popen2(cm )
	print "child pid =", self.pid
  	os.close(c2pwrite)










# ---------------------- Render keyboard ----------------------

    def render_kb(self,event):
	        global params
      		params=self.fill_params.get()
		app = r"C:\perso\bureautique\Microsoft Office\Office\excel.exe"
                appli = split(app)[1]
#		os.spawnl(os.P_NOWAIT, app , params)
#		os.system(app +' '+params)
#		os.system(app)
                spawnv(P_NOWAIT, app, (appli, params))


## ---------------------- POV-RAY executable location ----------------------

    def show_location(self):
      self.tl_exe_loc=Toplevel()
      self.tl_exe_loc.title("Pov-Ray executable location")
      self.pov_location=Entry(self.tl_exe_loc,width=60)
      if self.exe_loc.endswith("\n"):
        self.exe_loc = self.exe_loc[:-1]
      self.pov_location.insert(INSERT,self.exe_loc)
      self.ok=Button(self.tl_exe_loc, text="Search Pov-Ray location",command=self.ask_location)
      self.cancel=Button(self.tl_exe_loc, text="Exit",command=self.quit_ask_location)
      self.tl_exe_loc.focus_force()
      self.pov_location.pack()
      self.cancel.pack(side='left')
      self.ok.pack(side='right')




    def ask_location(self):
      self.tl_exe_loc.destroy()
      params=self.fill_params.get()
      self.exe_loc = askopenfilename()
      if self.exe_loc.endswith("\r\n"):
		self.exe_loc = self.exe_loc[:-2]
      if params.endswith("\r\n"):
		params = params[:-2]
#      fd = open("pyvon.ini", 'w')
#      fd.write("Location : "+self.exe_loc+"\n"+"Parameters : "+params+"\n"+"Directory : "+directory)
#      fd.close
      self.show_location()




    def quit_ask_location(self):
      self.tl_exe_loc.destroy()


## ---------------------- Save before exit ----------------------

    def save_on_exit(self):
      params=self.fill_params.get()
      if self.exe_loc.endswith("\n"):
        self.exe_loc = self.exe_loc[:-1]
      if params.endswith("\n"):
        params = params[:-1]
      global font
      if font.endswith("\n"):
	font = font[:-1]
      global font_size
      if font_size.endswith("\n"):
	font_size = font_size[:-1]
      fd = open("pyvon.ini", 'w')
      fd.write("Location : "+self.exe_loc+"\n"+"Parameters : "+params+"\n"+"Directory : "+directory+"\n"+"Font : "+font+"\n"+"Font size : "+font_size)
      fd.close




## ---------------------- Called when a key is pressed ----------------------
## ---------------------- Prints the current line number and contents ----------------------


    def keyPress(self,event):
        Ligne, column = self.text.index(INSERT).split('.', 1)
        self.status_line.config(text="%s" % (Ligne))

#        key_stroken=self.text.get('1.0','end')
#        print key_stroken






## ---------------------- Called when a key is released  ----------------------

#    def keyRelease(self,event):
#      l, c = self.text.index(INSERT).split('.', 1)
#      print l,c

#      print 'Current line is %s: "%s"' % (l, self.text.get("%s.end-1 chars" % l, "%s.end" % l))
#      key_stroken='%s' % (self.text.get("%s.end-1 chars" % l, "%s.end" % l))
#      buf.append(key_stroken)
#      print buf
#	    self.cursorStack.append( self.text.index( 'insert'))

#        Ligne, column = string.split( self.text.index(INSERT),'.')
#        print column
#        key_stroken=self.text.get(INSERT,INSERT-1)
#        print key_stroken
#        key_stroken=key.car.


## ---------------------- Loads the ini file ----------------------

    def loadini(self):
      fd=open("pyvon.ini")
      for line in fd.readlines():
        if line.find("Location :")==0:
          global exe_loc
          self.exe_loc=line[11:]
          if self.exe_loc.endswith("\n"):
            self.exe_loc=self.exe_loc[:-1]
        if line.find("Parameters :")==0:
          global params
          params=line[13:]
          if params.endswith("\n"):
            params=params[:-1]
        if line.find("Directory :")==0:
          global directory
          directory=line[12:]
          if directory.endswith("\n"):
            directory=directory[:-1]
        if line.find("Font :")==0:
          global font
          font=line[7:]
          if font.endswith("\n"):
            font=font[:-1]
        if line.find("Font size :")==0:
          global font_size
          font_size=line[12:]
          if font_size.endswith("\n"):
            font_size=font_size[:-1]
      fd.close()


## ---------------------- If loading the ini file fails --------------

    def loadinierror(self):
        self.tl=Toplevel()
        self.warninglb=Label(self.tl, font=('Verdana', 10, 'bold')
                             ,text="Warning\nYou must indicate where the\nPOV executable is located\nUse Render / POV-RAY location",fg="red")

        self.ok=Button(self.tl, text="OK", fg="red", command=self.destroywarning)
        self.ok.pack(side=BOTTOM)
        self.warninglb.focus_force()
        self.warninglb.pack()


    def destroywarning(self):
        self.tl.destroy()
        self.text.focus_force()


    def quitter(self):
        self.save_on_exit()
        sys.exit()


#    (os.path.join("Icons","new.gif")))

    def myfunc(self,chemin,nom):
        fd=open(os.path.join(chemin,nom))
        contents=fd.read()
        self.text.insert(INSERT,contents)
#        print contents
        fd.close()

    def insert_example(self,nom):
        chemin="insert"
        fd=open(os.path.join(chemin,nom))
        contents=fd.read()
        self.text.insert(INSERT,contents)
        fd.close()



    def destroyfont_panel(self):
      try:
        global font_size
        font_size=self.font_size.get()
        self.text.configure(font=(font, font_size))
        self.tl_font.destroy()
      except TclError:
        pass


    def choose_font(self):
      fonts=["arial","verdana","utopia","clean","clearlyu","fixed","helvetica",
			"lucida","menu","new","terminale","times","zapf chancery"]
      self.tl_font=Toplevel()
      self.tl_font.focus_force()
      self.tl_font.title("Font options")
      self.FG_font_choice=Frame(self.tl_font)
      self.FG_font_choice.pack(side="left")
      self.FM_font_choice=Frame(self.tl_font)
      self.FM_font_choice.pack(side="left")
      self.FD_font_choice=Frame(self.tl_font)
      self.FD_font_choice.pack(side="left")
      self.sep=Label(self.FM_font_choice,width=1,height=12)
      self.sep.pack()
## tells which font is currently used
      self.current_font=Label(self.FG_font_choice,text="Current font : %s" % (font),justify='left',height=2,width=20,anchor=NW)
      self.current_font.pack(side="top")
## tells which font size is currently used
      self.font_size=Label(self.FG_font_choice,text="Font size : %s" % (font_size),justify='left',height=2,width=20,anchor=NW)
      self.font_size.pack(side="top")
## etiquette Font size :
      self.etiquette_size=Label(self.FG_font_choice,text="New size :",justify='left')
      self.etiquette_size.pack(side="left")
## entry pour font_size
      self.font_size = Entry(self.FG_font_choice, exportselection=0, background="white",width=10)
      self.font_size.insert('end',font_size)
      self.font_size.pack(side="left")
## bouton pour valider
      self.ok=Button(self.FD_font_choice, text="OK", fg="red", command=self.destroyfont_panel)
      self.ok.pack(side='bottom')
      self.vbar = vbar = Scrollbar(self.FD_font_choice, name="vbar")
      self.vbar.pack(side="right", fill="y")
      self.etiquette_font=Label(self.FD_font_choice,text="Fonts",anchor=W)
      self.etiquette_font.pack(side="top")
      self.listbox = listbox = Listbox(self.FD_font_choice, exportselection=0, background="white")
      listbox.pack(expand=1, fill="both")
      for item in fonts:
        listbox.insert(END,item)

        # Tie listbox and scrollbar together
      vbar["command"] = listbox.yview
      listbox["yscrollcommand"] = vbar.set
        # Bind events to the list box
      listbox.bind("<ButtonRelease-1>", self.click_event)
        # Mark as empty
#      self.clear()

     
    def click_event(self, event):
        self.listbox.activate("@%d,%d" % (event.x, event.y))
        index = self.listbox.index("active")
        global font
        font=self.listbox.get(index)
        self.current_font.configure(text="Current font : %s" % (font))

        return "break"



    def make_menu(self):
        menu = Menu(self.listbox, tearoff=0)
        self.menu = menu
        self.fill_menu()


    def select(self, index):
        self.listbox.focus_set()
        self.listbox.activate(index)
        self.listbox.selection_clear(0, "end")
        self.listbox.selection_set(index)
        self.listbox.see(index)



affi_Ligne=StringVar()
#params=StringVar()
larg = root.winfo_screenwidth()
haut = root.winfo_screenheight()
app = App(root)
#root.geometry("%dx%d+0+0" % (larg,haut))
root.title("POV-RAY editor")


root.mainloop()


